// Key.c: implementation of the Key function.
//
//////////////////////////////////////////////////////////////////////
#include "Key.h"

#include "gpstdio.h"

int gpCursorBlend = 10;

struct
{
	int	UP;			// List of buttons with key-up buttons
	int	DOWN;		// List of buttons with key-down event
} KeyStatus;

void SetKeyStatus(void)
{
	static int nKeyPressed = 0;		// List of buttons pressed in previous loop

	int	nKey, k;

	KeyStatus.UP   = 0;
	KeyStatus.DOWN = 0;

	nKey = GpKeyGet();

	for (k = 0x0001 ; k <= 0x2000 ; k <<= 1)
	{
		// If pressed in previous loop & NOT pressed in current loop, key-up event has occurred
		if ((nKeyPressed & k) && !(nKey & k))
			KeyStatus.UP |= k;

		// If NOT pressed in previous loop & pressed in current loop, key-down event has occurred
		if (!(nKeyPressed & k) && (nKey & k))
			KeyStatus.DOWN |= k;
	}

	nKeyPressed = nKey;
}

int GetKey(void)
{
	return KeyStatus.DOWN;
}

void WaitKey(int nKey)
{
	while (1)
	{
		SetKeyStatus();
		if (KeyStatus.UP & nKey)
			break;
	}
}

void UpdateCursor(void)
{
	static BOOL bBlendMode = FALSE;

	// Make cursor mode
	if (bBlendMode == FALSE)
	{
		gpCursorBlend ++;
		if (gpCursorBlend > 50)
			bBlendMode = TRUE;
	}
	else
	{
		gpCursorBlend --;
		if (gpCursorBlend < 10)
			bBlendMode = FALSE;
	}
}
