#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "kscode.h"

#include "gpstdio.h"

typedef struct  {  // ѱ ڵ 
    WORD  lasc :5;
    WORD  midc :5;
    WORD  firc :5;
    WORD  dummy:1;
} hcode;

#define SINGLENUM  51  // ѱ  
#define SIZE_EXTKS  (sizeof(WORD) * 8822)
#define SIZE_KS    	(sizeof(WORD) * 2350)

//  ѱ ڵ ȯ
int  codecmp(const void *p,const void *q);
WORD comb2comb(HANCODE src, HANCODE dest, WORD code); //  --> 

WORD KSSM2KS(WORD code);      	//   -> ϼ
WORD KS2KSSM(WORD code);      	//  ϼ -> 
WORD KSSM2ExtKS(WORD code);  	//   -> Ȯϼ
WORD ExtKS2KSSM(WORD code);  	//  Ȯϼ -> 

static WORD ExtKSTable[8822];
static WORD KSTable[2350];

//  ѱ  51  ڵ
WORD SingleTable[SINGLENUM] = {
  	0x8841, 0x8c41, 0x8444, 0x9041, 0x8446, 0x8447, 0x9441, 0x9841,
  	0x9c41, 0x844a, 0x844b, 0x844c, 0x844d, 0x844e, 0x844f, 0x8450,
  	0xa041, 0xa441, 0xa841, 0x8454, 0xac41, 0xb041, 0xb441, 0xb841,
  	0xbc41, 0xc041, 0xc441, 0xc841, 0xcc41, 0xd041, 0x8461, 0x8481,
  	0x84a1, 0x84c1, 0x84e1, 0x8541, 0x8561, 0x8581, 0x85a1, 0x85c1,
  	0x85e1, 0x8641, 0x8661, 0x8681, 0x86a1, 0x86c1, 0x86e1, 0x8741,
  	0x8761, 0x8781, 0x87a1
};

//   ڵ ̺
//  ﺸ 
signed char KSSM1Table[32] = {
 	-1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
  	15, 16, 17, 18, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
};

signed char KSSM2Table[32] = {
  	-1, -1,  0,  1,  2,  3,  4,  5, -1, -1,  6,  7,  8,  9, 10, 11,
  	-1, -1, 12, 13, 14, 15, 16, 17, -1, -1, 18, 19, 20, 21, -1, -1
};

signed char KSSM2Table0[22] = {
  	 2,  3,  4,  5,  6,  7, 10, 11, 12, 13, 14, 15, 18, 19, 20, 21,
  	22, 23, 26, 27, 28, 29
};

signed char KSSM3Table[32] = {
  	-1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
  	15, 16, -1, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, -1, -1
};

signed char KSSM3Table0[28] = {
  	 1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
  	17, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29
};

WORD SpecTable[128] = {
    0xa1d9, 0xa1da, 0xa2be, 0xa1df, 0xa2c0, 0xa2bc, 0xa1dc, 0xa1e0,
    0xa1db, 0xa1e1, 0xa1ce, 0xa1cf, 0xa2dc, 0xa2dd, 0xa2b4, 0xa2ba,
    0xa2b8, 0xa2d5, 0xa3a1, 0xa2d2, 0xa1d7, 0xa1aa, 0xa2d9, 0xa1e8,
    0xa1e9, 0xa1e6, 0xa1e7, 0xa1d0, 0xa1ea, 0xa1e3, 0xa1e5, 0xeced,
    0xeac5, 0xfbfd, 0xe2a9, 0xd9ca, 0xd0dd, 0xf7cf, 0xd2b4, 0xa2cf,
    0xa1b8, 0xa1b9, 0xa8f6, 0xa8f9, 0xa3df, 0xa1ad, 0xa1c5, 0xa2c6,
    0xa2c7, 0xa2c8, 0xa6a2, 0xa6a9, 0xa6be, 0xa6b9, 0xa6c1, 0xa6c2,
    0xa6b4, 0xa6ad, 0xa6af, 0xa6b0, 0xa6c3, 0xa6c4, 0xa6a4, 0xa6a6,
    0xa6aa, 0xa6a8, 0xa6a7, 0xa6a1, 0xa6ab, 0xa6bc, 0xa6b7, 0xa6b1,
    0xa6ae, 0xa6b5, 0xa6b3, 0xa6b2, 0xa6ac, 0xa6b6, 0xa6ba, 0xa6bf,
    0xa6b8, 0xa6bd, 0xa6c5, 0xa6c6, 0xa6c8, 0xa6c7, 0xa6c0, 0xa6bb,
    0xa6a5, 0xa6a3, 0xa2c3, 0xa2c9, 0xa2ca, 0xa2cb, 0xa2cc, 0xa5e1,
    0xa9ac, 0xa5c3, 0xa5f0, 0xa5d2, 0xa5f2, 0xa5ec, 0xa5f3, 0xa5d5,
    0xa5e8, 0xa7d9, 0xa5e4, 0xa1c4, 0xa9aa, 0xa1f4, 0xa1fb, 0xa1d5,
    0xa1be, 0xa1c3, 0xa1c2, 0xa1f2, 0xa1f3, 0xa1c0, 0xa2cd, 0xa1a3,
    0xa1a4, 0xa1e7, 0xa1ee, 0xa9fa, 0xa9f7, 0,      0,      0xaec2,
};

//---------------------------------------------------------------------------
WORD comb2comb(HANCODE src, HANCODE dest, WORD code)
{
  	int  firc, midc, lasc;

  	if (src == dest)
  		return code;

  	firc = ((hcode *) &code)->firc;
  	midc = ((hcode *) &code)->midc;
  	lasc = ((hcode *) &code)->lasc;

  	if (src == CODE_KSSM)
  	{
    	firc = KSSM1Table[firc];
    	midc = KSSM2Table[midc];
    	lasc = KSSM3Table[lasc];
  	}

  	if (firc < 0 || midc < 0 || lasc < 0)
  		return 0;

  	if (dest == CODE_KSSM)
  	{
    	firc++;
    	midc = KSSM2Table0[midc];
    	lasc = KSSM3Table0[lasc];
  	}

  	return (0x8000 + (firc << 10) + (midc << 5) + lasc);
}
//---------------------------------------------------------------------------
int codecmp(const void *p,const void *q)
{
  	LPWORD p1 = (LPWORD) p;
  	LPWORD q1 = (LPWORD) q;

  	return (*p1 - *q1);
}
//---------------------------------------------------------------------------
WORD KSSM2ExtKS(WORD Code)
{
  	WORD 	newCode;
  	WORD 	index;
  	LPWORD 	p;
  	BYTE 	high, low;

  	newCode = KSSM2KS(Code);
  	if (newCode == 0)
  	{
    	if ((p = (LPWORD) bsearch(&Code, ExtKSTable, SIZE_EXTKS / sizeof(WORD), sizeof(WORD), codecmp)) != NULL)
      		index = p - ExtKSTable;
    	else
    		return  0;

    	if (index < 5696)
    	{
      		high = (index / 178) + 0x81;
      		index %= 178;
      		if (index < 26)
      			low = 0x41 + index;
      		else if (index < 52)
      			low = 0x61 + index - 26;
      		else
      			low = 0x81 + index - 52;
    	}
    	else if (index < 8804)
    	{
      		index -= 5696;
      		high = (index / 84) + 0xA1;
      		index %= 84;
      		if (index < 26)
      			low = 0x41 + index;
      		else if (index < 52)
      			low = 0x61 + index - 26;
      		else
      			low = 0x81 + index - 52;
    	}
    	else
    	{
      		high = 0xC6;
      		low = (index - 8804) % 18 + 0x41;
    	}
    	newCode = (((WORD) high) << 8) + low;
  	}

  	return newCode;
}
//---------------------------------------------------------------------------
WORD ExtKS2KSSM(WORD Code)
{
  	WORD newCode;
  	BYTE high, low;
  	WORD index;

  	newCode = KS2KSSM(Code);
  	if (newCode == 0)
  	{
    	high = (BYTE) (Code >> 8);
    	low  = (BYTE) Code;
    	if (high >= 0x81 && high <= 0xA0)
    	{
      		index = (high - 0x81) * 178;
      		if (low >= 0x41 && low <= 0x5A)
      			index += (low - 0x41);
      		else if (low >= 0x61 && low <= 0x7A)
      			index += (low - 0x61 + 26);
      		else
      			index += (low - 0x81 + 52);
    	}
    	else if (high >= 0xA1 && high <= 0xC5)
    	{
      		index = (high - 0xA1) * 84 + 5696;
      		if (low >= 0x41 && low <= 0x5A)
      			index += (low - 0x41);
      		else if (low >= 0x61 && low <= 0x7A)
      			index += (low - 0x61 + 26);
      		else
      			index += (low - 0x81 + 52);
    	}
    	else if (high == 0xC6 && low >= 0x41 && low <= 0x52)
      		index = (low - 0x41 + 8804);

    	if (index >= 8822)
    		return 0;

    	newCode = ExtKSTable[index];
  	}

  	return newCode;
}
//---------------------------------------------------------------------------
WORD KSSM2KS(WORD code)
{
  	BYTE  high, low;
  	BYTE  temp;
  	int   index;
  	LPWORD p;

  	high = (BYTE)(code >> 8);
  	low  = (BYTE)code;

  	if (high == 0xd4)
  	{
    	index = low-0x81;
    	if (index < 128)
      		return SpecTable[index];
  	}

  	// ѱ ȯ
  	if ((p = (LPWORD) bsearch(&code, KSTable, 2350, sizeof(WORD), codecmp)) != NULL)
  	{
    	index = p - KSTable;
    	return ((((index / 94)+0xb0)<<8)+(index % 94) + 0xa1);
  	}
  	// Ư  ȯ1
  	else
  	{
    	if (high >= 0xd9 && high <= 0xde)
    	{
      		if (low < 0x30 || (low > 0x7e && low < 0x91))
        		return(0);
      		if (low >= 0xa1)
        		temp = (high - 0xd9) * 2 + 0xa1 + 1;
      		else
      		{
        		temp = (high - 0xd9) * 2 + 0xa1;
        		if (low <= 0x7e)
        			low += 0x70;
        		else
        			low += (0x70 - 18);
      		}

      		return ((temp << 8) + low);
    	}
    	// Ư  ȯ2
    	else
    	{
      		if (high == 0xd4)
      		{
        		if (low < 0x80)
        			return  0;
        		if (low <= 0xdd)
        		{
          			temp = 0xad;
          			low += 0x21;
        		}
        		else
        		{
          			temp = 0xae;
          			low -= 0x3d;
        		}

        		return ((temp << 8) + low);
      		}
      		//  ȯ
      		else if (high >= 0xe0 && high <= 0xf9)
      		{
        		if (low < 0x30 || (low > 0x7e && low < 0x91))
        			return 0;
        		if (low >= 0xa1)
        			temp = (high - 0xe0) * 2 + 0xca + 1;
        		else
        		{
          			temp = (high - 0xe0) * 2 + 0xca;
          			if (low <= 0x7e)
          				low += 0x70;
          			else
          				low += (0x70 - 18);
        		}

        		return ((temp << 8) + low);
      		}
    	}
  	}

  	for (index = 0;index < SINGLENUM;index++)
    	if (SingleTable[index] == code)
    		return(0xa4a1 + index);

  	return (0);
}
//---------------------------------------------------------------------------
WORD KS2KSSM(WORD code)
{
  	BYTE high, low;
  	BYTE temp;
  	int  index;
  	int  mod, rem;

  	high = (BYTE)(code >> 8);
  	low  = (BYTE)code;

  	// Ư  ȯ1
  	if (high >= 0xa1 && high <= 0xac)
  	{
    	if (low < 0xa1 || low > 0xfe)
    		return 0;
    	mod = (high - 0xa1) >> 1;
    	rem = (high - 0xa1) & 0x01;
    	if (rem)
    		temp = low;
    	else
    	{
      		temp = low - 0x70;
      		if (temp > 0x7e)
      			temp += 18;
    	}
    	return (((mod + 0xd9) << 8) + temp);
  	}
  	// Ư  ȯ2
  	else if( high == 0xad)
  	{
    	if (low < 0xa1 || low > 0xfe)
    		return 0;

    	temp = low - 0x21;
    	return ((0xd4 << 8) + temp);
  	}
  	// Ư  ȯ3
  	else if( high == 0xae)
  	{
    	if (low < 0xa1 || low > 0xc1)
    	{
      		if (low == 0xc2)
      			return 0xd4ff;
      		return 0;
    	}

    	temp = low + 0x3d;
    	return ((0xd4 << 8) + temp);
  	}
  	// ѱ ȯ
  	else if (high >= 0xb0 && high <= 0xc8)
  	{
    	if (low < 0xa1 || low > 0xfe)
    		return (0);

    	index = (high - 0xb0) * 94 + low - 0xa1;
    	return (KSTable[index]);
  	}
  	//  ȯ
  	else if (high >= 0xca && high <= 0xfd)
  	{
    	if (low < 0xa1 || low > 0xfe)
    		return (0);
    	mod = (high - 0xca) >> 1;
    	rem = (high - 0xca) & 0x01;
    	if (rem)
    		temp = low;
    	else
    	{
      		temp = low - 0x70;
      		if (temp > 0x7e)
      			temp += 18;
    	}
    	return (((mod + 0xe0) << 8) + temp);
  	}

  	index = ((code >> 8) - 0xb0) * 94 + (code & 0x00ff) - 0xa1;
  	if (index < 0 || index >= 2350)
  		return  0;

  	return (KSTable[index]);
}


//---------------------------------------------------------------------------
#define KS5061_VERIFY_COUNT 512  // ϼڵ Ȯ Ƚ

//---------------------------------------------------------------------------
static BOOL CheckKSRange(int hancode, int HexStart, int HexEnd, int max)
{
	int i;
  	for (i = 0; i < max; i++)
  	{
    	if (hancode > HexStart+0x0100*i && hancode < HexEnd+0x0100*i)
      		return TRUE;
  	}

  	return FALSE;
}
//---------------------------------------------------------------------------
#define MAX_CODE  48
static BOOL IsKSSM(int hancode)
{
	static int kssmcode[MAX_CODE] = {
    0x8877,  //  ``
    0x8969,  //  ``
    0x89a1,  //  ``
    0x8b71,  //  ``
    0x8fa1,  //  ``
    0x9281,  //  ``
    0x9c61,  //  ``
    0x9e81,  //  ``
    0xa061,  //  ``
    0xa0f5,  //  ``
    0xa2a1,  //  ``
    0xa3a8,  //  ``
    0xa4e1,  //  ``
    0xa4e5,  //  ``
    0xa4f1,  //  ``
    0xa5c1,  //  ``
    0xa7a1,  //  ``
    0xa8b1,  //  ``
    0xaca1,  //  ``
    0xace1,  //  ``
    0xace2,  //  ``
    0xace3,  //  ``
    0xace4,  //  ``
    0xace5,  //  `
    0xace6,  //  ``
    0xace7,  //  ``
    0xace8,  //  ``
    0xace9,  //  ``
    0xb3a2,  //  ``
    0xb4a1,  //  ``
    0xb4a2,  //  ``
    0xb4e1,  //  ``
    0xb4f1,  //  ``
    0xb4f4,  //  ``
    0xb541,  //  ``
    0xb5e1,  //  ``
    0xb765,  //  ``
    0xb8e5,  //  ``
    0xb941,  //  ``
    0xb9a1,  //  ``
    0xb9a5,  //  ``
    0xb9c1,  //  ``
    0xc561,  //  ``
    0xc7a1,  //  `Ű`
    0xcfa1,  //  ``
    0xdbad,  //  ``
    0xdccf,  //  ``
    0xe7e6,  //  ``
  	};

  	// 1998.2.23  ߰(Cherie)
  	//  Ͼ  ϼ  κ ִµ,
  	// ϼ   ʴ ̹Ƿ,
  	// Ʒ ڵ尡    ν
  	//   Ͼ ڵ尡 ƴ϶...
	if (hancode == 0xb7e7)
		return FALSE;

  	if ((int *) bsearch(&hancode, kssmcode, MAX_CODE, sizeof(int), codecmp) != NULL ||
        (hancode >= 0xd000 && hancode <= 0xd3ff) ||
        (hancode >= 0xdda1 && hancode <= 0xde98) ||
        (hancode >= 0xdba1 && hancode <= 0xdbc8) ||

      	// 1998.04.22 ߰(Cherie)
      	//  ѱ  ν  ʴ  ذ
      	// Ʒ ڵ尡    ν
      	// 1998.05.05 (Cherie)
      	// Ϻ ϼ ڵ尡  νϴ  ־
      	// ˻  0xb400 - 0xb8ff  0xb400 - 0xb7ff ٲ
      	// 1998.07.28 (Cherie)
      	//  ϼ Ѵ Ǵ ڵ, ϼ 
      	//  ʴ ڵ  ڵ Ѵ.
      	(hancode >= 0xc500 && hancode <= 0xc5ff) ||
      	(hancode >= 0xb700 && hancode <= 0xb7cd) ||
      	(hancode >= 0xb7cf && hancode <= 0xb7ff) ||

      	// 1998.04.28 ߰(Cherie)
      	//  ϰ   ν
      	(hancode >= 0xda00 && hancode <= 0xdaff) ||

      	// 1998.2.23  ߰(Cherie)
      	//  ϰ쵵   ν
      	//    ڵ尡 ƴ϶...
      	(hancode >= 0xd9b0 && hancode <= 0xd9cf) ||
      	(hancode >= 0xd4b0 && hancode <= 0xd4cf) )
    	return TRUE;

  	return FALSE;
}
//---------------------------------------------------------------------------
BOOL IsKS(LPBYTE buf, int len)
{
  	int  i, hancode;

  	BYTE first, second;
  	int  ks_count = 0;
  	int  kssm_count = 0;
  	int  count = 0;

  	for (i = 0; i < len; i++)
  	{
    	first = buf[count];
    	count ++;
    	if (first < 0x80)
    		continue; //  ѱڵ尡 ƴ϶

    	second = buf[count];

    	if (count > 10240)
    		break;

    	if (count >= len)
    		break;

    	count ++;

    	hancode = (first << 8) + second;  // ѱڵ带 ϱ

    	//  ϼ Ѵ  ̴ ڵϰ쿡
    	// īƮ ʴ´.
    	if (hancode >= 0xb500 && hancode < 0xb5ff &&
        	hancode != 0xb5a5 && hancode != 0xb5e1 &&
        	hancode != 0xb541)
      		continue;

    	// ϼ ,,,,  ڴ   ̴
    	// ̹Ƿ īƮ  ʴ´.
    	if (hancode == 0xbba1 ||
        	hancode == 0xb7a1 ||
        	hancode == 0xb4e5 ||
        	hancode == 0xb7b6 ||
        	hancode == 0xb4f6 ||
        	hancode == 0xb8e1 ||  //  ``
        	hancode == 0xb1c1 ||  //  ``
        	hancode == 0xbaa1 ||  //  ``
        	hancode == 0xbba5 ||  //  ``
        	hancode == 0xb6a1 ||  //  ``/``
        	hancode == 0xb6e1 ||  //  ``
        	hancode == 0xa1a1)
        	continue;

        //   KS5061 Ư ڵΰ?
    	if (((hancode > 0xa1a2 && hancode < 0xa1ff) ||
        	 (hancode > 0xa2a0 && hancode < 0xa2e6) ||
        	 (hancode > 0xa3a0 && hancode < 0xa3ff) ||
        	 (hancode > 0xa4a0 && hancode < 0xa4ff) ||
        	 (hancode > 0xa5a0 && hancode < 0xa5f9) ||
        	 (hancode > 0xa6a0 && hancode < 0xa6e5) ||
        	 (hancode > 0xa7a0 && hancode < 0xa7f0) ||
        	 (hancode > 0xa8a0 && hancode < 0xa8ff) ||
	         (hancode > 0xa9a0 && hancode < 0xa9ff) ||
        	 (hancode > 0xaaa0 && hancode < 0xaaf4) ||
        	 (hancode > 0xaba0 && hancode < 0xabf7) ||
        	 (hancode > 0xaca0 && hancode < 0xacc2) ||
        	 (hancode > 0xacd0 && hancode < 0xacf2) ||

        	 //  1998.2.21  ߰(Cherie)
        	 hancode == 0xaec2 ||

        	 //  1998.8.31  ߰(Cherie)
        	 (hancode > 0xadd0 && hancode < 0xadff) ||

        	 // KS5061 ѱڵΰ?
        	 CheckKSRange(hancode, 0xb0a0, 0xb0ff, 16) ||
        	 CheckKSRange(hancode, 0xc0a0, 0xc0ff, 9) ||

        	 (hancode == 0xb8ae) ||
        	 (hancode == 0xb7e7) || // ϼ ''

        	 // KS5061 ڵΰ?
        	 CheckKSRange(hancode, 0xcaa0, 0xcaff, 6) ||
        	 CheckKSRange(hancode, 0xd0a0, 0xd0ff, 16) ||
        	 CheckKSRange(hancode, 0xe0a0, 0xe0ff, 16) ||
        	 CheckKSRange(hancode, 0xf0a0, 0xf0ff, 14)) &&

        	// 1998.08.22 (Cherie)
        	//  ϼ Ѵ Ǵ ڵ,  
        	// Ǵ ڵ   ڵ Ѵ.
        	!IsKSSM(hancode))
    	{
      		if (++ks_count >= KS5061_VERIFY_COUNT)
        		break;
    	}
    	else
    	{
      		if (++kssm_count >= KS5061_VERIFY_COUNT)
        		break;
    	}
  	}

  	//  κ ٴ ϼ  Ƿ īƮ 
  	//    ϼ óϵ Ѵ.
  	if (ks_count >= kssm_count)
    	return TRUE;

   	return FALSE;
}

enum CODETYPE GetCodeType(LPBYTE str, int pos)
{
  	enum CODETYPE type = CODE_ENG;
  	LPBYTE ptr = str;

  	while (*ptr)
  	{
    	type = (type == CODE_FIRST) ? CODE_LAST : (*ptr >= 0x80 ? CODE_FIRST : CODE_ENG);
    	if (pos == 0)
    		return type;

    	pos --;
    	ptr ++;
  	}

  	return CODE_NONE;
}

//---------------------------------------------------------------------------
BOOL LoadExtKSTable(void)
{
	ERR_CODE result;

	F_HANDLE fHandle;
	DWORD	 dwDummy;

	char szPath[255];

	sprintf(szPath, "%s\\GPFM\\EXTKS.TBL", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, ExtKSTable, SIZE_EXTKS, &dwDummy);
    GpFileRead(fHandle, KSTable,    SIZE_KS, &dwDummy);
    GpFileClose(fHandle);

    return TRUE;
}
