#include <stdio.h>

#include "Textout.h"

#include "gpstdio.h"

#include "Kscode.h"

const char _HANTABLE[3][32] =
{
    { 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
     15,16,17,18,19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 1, 2, 3, 4, 5, 0, 0, 6, 7, 8, 9,10,11,
      0, 0,12,13,14,15,16,17, 0, 0,18,19,20,21, 0, 0 },
    { 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
     15,16, 0,17,18,19,20,21,22,23,24,25,26,27, 0, 0 }
};

const char _INDEX1[] =
{
	5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7, 7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
};
const char _INDEX2[] =
{
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
};
const char _INDEX3[] =
{
	0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0, 2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
};

// 8x10
static BYTE _engfont[128][9];

static BYTE _hanfirst[8][20][10];
static BYTE _hansecond[4][22][10];
static BYTE _hanlast[4][28][10];

// 16x16
static BYTE _engfontext[128][16];

static BYTE _hanfirstext[8][20][32];
static BYTE _hansecondext[4][22][32];
static BYTE _hanlastext[4][28][32];

// 16x16
static BYTE _hanjafont[4888][32];
static BYTE _graphfont[1177][32];
static BYTE _spcfont[128][32];

static BYTE _hanbuffer[32];

//
void (*GpTextOutXY)(int x, int y, char* lpszText, WORD wColor);
void (*GpTextOutXY16)(int x, int y, char* lpszText, WORD wColor);

/*
void GpPutBitmap8x16(int x, int y, LPBYTE lpBitmap, WORD wColor)
{
	int nCol, nRow, nSkipCol;
	LPBYTE pBitmap  = lpBitmap;
	LPWORD pSurface = LCD_GET_ADDRESS(x, y + 7);

	nSkipCol = LCD_PHYSICAL_W - 8;
    for (nRow = 0; nRow < 16; nRow ++)
    {
        BYTE data = *pBitmap ++;
        for (nCol = 0; nCol < 8; nCol ++)
        {
            if (data & 0x80)
            	*pSurface = wColor;

            pSurface ++;
            data <<= 1;
        }

        pSurface += nSkipCol;
    }
}
*/

static void PutBitmap5x9(int x, int y, LPBYTE lpBitmap, WORD wColor)
{
	LPBYTE pBitmap = lpBitmap;

	int nRow = 9;
    while (nRow --)
    {
        BYTE data = *pBitmap ++;

    	int nCol = 5;
        while (nCol --)
        {
            if (data & 0x80)
            	LCD_PUT_PIXEL(x + (5 - nCol), y + (9 - nRow), wColor);

            data <<= 1;
        }
    }
}
static void PutBitmap8x10(int x, int y, LPBYTE lpBitmap, WORD wColor)
{
	LPBYTE pBitmap = lpBitmap;

	int nRow = 10;
    while (nRow --)
    {
        BYTE data = *pBitmap ++;

    	int nCol = 8;
        while (nCol --)
        {
            if (data & 0x80)
            	LCD_PUT_PIXEL(x + (8 - nCol), y + (10 - nRow), wColor);

            data <<= 1;
        }
    }
}

static void PutBitmap8x16(int x, int y, LPBYTE lpBitmap, WORD wColor)
{
	LPBYTE pBitmap = lpBitmap;

	int nRow = 16;
    while (nRow --)
    {
        BYTE data = *pBitmap ++;

    	int nCol = 8;
        while (nCol --)
        {
            if (data & 0x80)
            	LCD_PUT_PIXEL(x + (8 - nCol), y + (16 - nRow), wColor);

            data <<= 1;
        }
    }
}
static void PutBitmap16x16(int x, int y, LPBYTE lpBitmap, WORD wColor)
{
	LPBYTE pBitmap = lpBitmap;

	int nRow = 16;
    while (nRow --)
    {
        BYTE data = *pBitmap ++;

    	int nCol = 8;
        while (nCol --)
        {
            if (data & 0x80)
            	LCD_PUT_PIXEL(x + (8 - nCol), y + (16 - nRow), wColor);

            data <<= 1;
        }

		//
        data = *pBitmap ++;

    	nCol = 8;
        while (nCol --)
        {
            if (data & 0x80)
            	LCD_PUT_PIXEL(x + 8 + (8 - nCol), y + (16 - nRow), wColor);

            data <<= 1;
        }
    }
}
static void ClearImage(int nLength)
{
	LPBYTE pBuffer = _hanbuffer;

	int nCount = nLength;
	while (nCount --)
		*pBuffer ++ = 0;
}
static void CopyImage(LPBYTE lpBuffer, int nLength)
{
	LPBYTE pBuffer = _hanbuffer;

	int nCount = nLength;
	while (nCount --)
		*pBuffer ++ = *lpBuffer ++;
}
static void MixerImage(LPBYTE lpBuffer, int nLength)
{
	LPBYTE pBuffer = _hanbuffer;

	int nCount = nLength;
	while (nCount --)
		*pBuffer ++ |= *lpBuffer ++;
}

static void PutEngFontXY(int x, int y, BYTE c, WORD wColor)
{
    LPBYTE _engbuffer = (LPBYTE) _engfont + c * 9;
    PutBitmap5x9(x, y + 1, _engbuffer, wColor);
}
static void PutEngFontXY16(int x, int y, BYTE c, WORD wColor)
{
    LPBYTE _engbuffer = (LPBYTE) _engfontext + c * 16;
    PutBitmap8x16(x, y, _engbuffer, wColor);
}

static void PutHanFontXY(int x, int y, BYTE data1, BYTE data2, WORD wColor)
{
    int  b1, b2, b3, h1, h2, h3;

	b1 = (data1 & 124) >> 2;
	b2 = (data1 & 3) * 8 + (data2 >> 5);
	b3 = (data2 & 31);

    h1 = _HANTABLE[0][b1];
    h2 = _HANTABLE[1][b2];
    h3 = _HANTABLE[2][b3];

	b1 = h3 ? _INDEX1[h2] : _INDEX2[h2];
	b2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	b3 = _INDEX3[h2];

	// first
	if (h1)
		CopyImage(_hanfirst[b1][h1], 10);
	else
		ClearImage(10);

	// middle
	if (h2)
		MixerImage(_hansecond[b2][h2], 10);

	// last
	if (h3)
		MixerImage(_hanlast[b3][h3], 10);

	PutBitmap8x10(x, y, _hanbuffer, wColor);
}

static BOOL IsGraph(BYTE data1, BYTE data2)
{
    static int fontID[] = {0xd480, 0xd931, 0xda31, 0xdb31, 0xdc31, 0xdd31, 0xde31};

	int nCount;
    for (nCount = 0; nCount < 7; nCount ++)
    {
    	BYTE hc1, hc2;

        hc1 = (fontID[nCount] >> 8) & 0xff;
        hc2 = (fontID[nCount] & 0xff);
        if ((data1 == hc1) && (data2 >= hc2))
        	return TRUE;
    }

    return FALSE;
}
static BOOL IsHanja(BYTE data1, BYTE data2)
{
    if ((data1 >= 0xe0 && data1 <= 0xfa) && ((data2 >= 0x31 && data2 <= 0x7e) || (data2 >= 0x91 && data2 <= 0xfe)))
    	return TRUE;

    return FALSE;
}
static BOOL IsSpc(BYTE data1, BYTE data2)
{
    if (data1 == 212 && data2 >= 0x80)
    	return TRUE;

    return FALSE;
}

static void PutGraphFontXY16(int x, int y, BYTE data1, BYTE data2, WORD wColor)
{
    int fontID[] = {0xd480, 0xd931, 0xda31, 0xdb31, 0xdc31, 0xdd31, 0xde31};
    int addoff[] = {125, 162, 188, 162, 188, 177, 175};
    int sblank[] = {1, 1, 0, 0, 0, 0, 0};

    BYTE hc1, hc2;
    int 	nCount;
    DWORD 	dwOffset;

    for (nCount = 0; nCount < 7; nCount ++)
    {
        hc1 = (fontID[nCount] >> 8) & 0xff;
        hc2 = (fontID[nCount] & 0xff);
        if (data1 == hc1 && data2 >= hc2)
        	break;
    }

    dwOffset = data2 - hc2;

    if ((dwOffset < sblank[nCount]) || (data2 >= 0x78 && data2 <= 0x89) || (data2 >= (addoff[nCount] + 0x31 + 18 + sblank[nCount])))
        dwOffset = 486;

    if (hc1 == 0xd4)
    {
        dwOffset = data2 - hc2;
        if (dwOffset > addoff[nCount] || dwOffset == 0)
        	dwOffset = 486;
    }

    if (dwOffset != 486)
    {
    	int nRow;

        if ((hc1 != 0xd4) && (data2 >= 0x8a))
        	dwOffset -= 18;

        dwOffset -= sblank[nCount];
        for (nRow = 0; nRow < nCount; nRow ++)
        	dwOffset += addoff[nRow];
    }

	PutBitmap16x16(x, y, _graphfont[dwOffset], wColor);
}
static void PutHanjaFontXY16(int x, int y, BYTE data1, BYTE data2, WORD wColor)
{
	DWORD dwOffset;

    if (data2 > 0x90)
    	data2 -= 0x12;

    data2 -= 0x31;
    dwOffset = ((data1 - 0xe0) * 188 + data2);

    PutBitmap16x16(x, y, _hanjafont[dwOffset], wColor);
}
static void PutSpcFontXY16(int x, int y, BYTE data1, BYTE data2, WORD wColor)
{
    PutBitmap16x16(x, y, _spcfont[data2 - 128], wColor);
}

static void PutHanFontXY16(int x, int y, BYTE data1, BYTE data2, WORD wColor)
{
    int  b1, b2, b3, h1, h2, h3;

	if (IsSpc(data1, data2))
		PutSpcFontXY16(x, y, data1, data2, wColor);
	else if (IsGraph(data1, data2))
		PutGraphFontXY16(x, y, data1, data2, wColor);
    else if (IsHanja(data1, data2))
		PutHanjaFontXY16(x, y, data1, data2, wColor);
	else
	{
		b1 = (data1 & 124) >> 2;
		b2 = (data1 & 3) * 8 + (data2 >> 5);
		b3 = (data2 & 31);

	    h1 = _HANTABLE[0][b1];
	    h2 = _HANTABLE[1][b2];
	    h3 = _HANTABLE[2][b3];

		b1 = h3 ? _INDEX1[h2] : _INDEX2[h2];
		b2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
		b3 = _INDEX3[h2];

		// first
		if (h1)
			CopyImage(_hanfirstext[b1][h1], 32);
		else
			ClearImage(32);

		// middle
		if (h2)
			MixerImage(_hansecondext[b2][h2], 32);

		// last
		if (h3)
			MixerImage(_hanlastext[b3][h3], 32);

		PutBitmap16x16(x, y, _hanbuffer, wColor);
	}
}

//
void GpKSTextOutXY(int x, int y, char* lpszText, WORD wColor)
{
	int nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	while (*pszText != '\0')
	{
		data1 = (BYTE) *pszText ++;
		if (data1 & 0x80)
		{
			WORD kssm;
			data2 = (BYTE) *pszText ++;

			// Convert KS -> KSSM
            kssm = ExtKS2KSSM(data1 << 8 | data2);

            data1 = (kssm >> 8) & 0xff;
            data2 = kssm & 0xff;

			PutHanFontXY(nPos, y, data1, data2, wColor);

			nPos += 9;
		}
		else
		{
			PutEngFontXY(nPos, y, data1, wColor);

			nPos += 6;
		}
	}
}
void GpKSTextOutXY16(int x, int y, char* lpszText, WORD wColor)
{
	int nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	while (*pszText != '\0')
	{
		data1 = (BYTE) *pszText ++;
		if (data1 & 0x80)
		{
			WORD kssm;
			data2 = (BYTE) *pszText ++;

			// Convert KS -> KSSM
            kssm = ExtKS2KSSM(data1 << 8 | data2);

            data1 = (kssm >> 8) & 0xff;
            data2 = kssm & 0xff;

			PutHanFontXY16(nPos, y, data1, data2, wColor);

			nPos += 16;
		}
		else
		{
			PutEngFontXY16(nPos, y, data1, wColor);

			nPos += 8;
		}
	}
}

void GpKSSMTextOutXY(int x, int y, char* lpszText, WORD wColor)
{
	int nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	while (*pszText != '\0')
	{
		data1 = (BYTE) *pszText ++;
		if (data1 & 0x80)
		{
			data2 = (BYTE) *pszText ++;
			PutHanFontXY(nPos, y, data1, data2, wColor);

			nPos += 9;
		}
		else
		{
			PutEngFontXY(nPos, y, data1, wColor);

			nPos += 6;
		}
	}
}
void GpKSSMTextOutXY16(int x, int y, char* lpszText, WORD wColor)
{
	int nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	while (*pszText != '\0')
	{
		data1 = (BYTE) *pszText ++;
		if (data1 & 0x80)
		{
			data2 = (BYTE) *pszText ++;
			PutHanFontXY16(nPos, y, data1, data2, wColor);

			nPos += 16;
		}
		else
		{
			PutEngFontXY16(nPos, y, data1, wColor);

			nPos += 8;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
void GpKSTextOutLXY(int x, int y, char* lpszText, int nLength, WORD wColor)
{
	int  nCount, nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	for (nCount = 0; nCount < nLength; nCount ++)
	{
		data1 = (BYTE) *pszText ++;
		if (data1 == 0x0D || data1 == 0x0A)
			continue;

		// TAB
		if (data1 == 0x09)
		{
			nCount += 4;
			nPos += 32;
			continue;
		}

		if (data1 & 0x80)
		{
			WORD kssm;
			data2 = (BYTE) *pszText ++;

			// Convert KS -> KSSM
            kssm = ExtKS2KSSM(data1 << 8 | data2);

            data1 = (kssm >> 8) & 0xff;
            data2 = kssm & 0xff;

			PutHanFontXY16(nPos, y, data1, data2, wColor);

			nPos += 16;
			nCount ++;
		}
		else
		{
			PutEngFontXY16(nPos, y, data1, wColor);

			nPos += 8;
		}
	}
}
void GpKSSMTextOutLXY(int x, int y, char* lpszText, int nLength, WORD wColor)
{
	int nCount, nPos = x;
	char* pszText = lpszText;

	BYTE data1, data2;
	for (nCount = 0; nCount < nLength; nCount ++)
	{
		data1 = (BYTE) *pszText ++;
		if (data1 == 0x0D || data1 == 0x0A)
			continue;

		// TAB
		if (data1 == 0x09)
		{
			nCount += 4;
			nPos += 32;
			continue;
		}

		if (data1 & 0x80)
		{
			data2 = (BYTE) *pszText ++;
			PutHanFontXY16(nPos, y, data1, data2, wColor);

			nPos += 16;
			nCount ++;
		}
		else
		{
			PutEngFontXY16(nPos, y, data1, wColor);

			nPos += 8;
		}
	}
}

void GpSetHanCode(HANCODE hancode)
{
	switch (hancode)
	{
	case CODE_KS:
		GpTextOutXY   = GpKSTextOutXY;
		GpTextOutXY16 = GpKSTextOutXY16;
		break;

	case CODE_KSSM:
		GpTextOutXY   = GpKSSMTextOutXY;
		GpTextOutXY16 = GpKSSMTextOutXY16;
		break;
	}
}

BOOL GpInitFont(void)
{
	ERR_CODE result;

	F_HANDLE fHandle;
	DWORD	 dwDummy;

	char szPath[255];

	// ExtKSTable
	if (!LoadExtKSTable())
		return FALSE;

	// 8x10
	sprintf(szPath, "%s\\GPFM\\H0.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _hanfirst,  8 * 20 * 10, &dwDummy);
    GpFileRead(fHandle, _hansecond, 4 * 22 * 10, &dwDummy);
    GpFileRead(fHandle, _hanlast,   4 * 28 * 10, &dwDummy);
    GpFileClose(fHandle);

	sprintf(szPath, "%s\\GPFM\\E0.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _engfont, 128 * 9, &dwDummy);
    GpFileClose(fHandle);

	// 16x16
	sprintf(szPath, "%s\\GPFM\\H1.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _hanfirstext,  8 * 20 * 32, &dwDummy);
    GpFileRead(fHandle, _hansecondext, 4 * 22 * 32, &dwDummy);
    GpFileRead(fHandle, _hanlastext,   4 * 28 * 32, &dwDummy);
    GpFileClose(fHandle);

	sprintf(szPath, "%s\\GPFM\\E1.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _engfontext, 128 * 16, &dwDummy);
    GpFileClose(fHandle);

	// HANJA
	sprintf(szPath, "%s\\GPFM\\HANJA.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _hanjafont, 4888 * 32, &dwDummy);
    GpFileClose(fHandle);

	// GRAPH
	sprintf(szPath, "%s\\GPFM\\SANGRF.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _graphfont, 1177 * 32, &dwDummy);
    GpFileClose(fHandle);

	// SPC
	sprintf(szPath, "%s\\GPFM\\SPC.FNT", gpAppPath);
    result = GpFileOpen(szPath, OPEN_R, &fHandle);
	if (result != SM_OK)
		return FALSE;

    GpFileRead(fHandle, _spcfont, 128 * 32, &dwDummy);
    GpFileClose(fHandle);


	// Set default KS code
	GpSetHanCode(CODE_KS);

    return TRUE;
}

